var feeds = new Array();
var savedItems = new Array()
var hashItems = new Object();
var NEWROW = 15;
var MAXCHANNELS = 15*2;
var timer;           // timer for actually reading

var intervalTicker = new Timer();
var menuItems = null;

var itemsToRead = 0;
var channelName;
var buttonArray = new Array();
var isScheduled = false;
var buttonSpeaker;
var buttonHelp;
var buttonHide;
var readingFeed = false;
var formActive = false;
var silence = false;

var bannerText = new Array();

function stopRead(){
	silence = true;
}

function randomSelect(){
	var no = Math.floor(Math.random() * MAXCHANNELS);
	changeChannel(no);
}


function Item(title,description,link){
	this.title = title;
	this.description = RemoveMarkup(description);
	this.link = link;
	this.read = false;
}

function url_done(url){
	url.result
	try {
		var doc = XMLDOM.parse(url.result); 
		buttonArray[url.number].tooltip = doc.evaluate("rss/channel/title").item(0).firstChild.data;
	} catch (ex){
	}
}

function showStation(no){
	try{
		var url = new URL();
		currentButton = buttonArray[no];
		url.location = feeds[no];
		url.number = no;
		url.fetchAsync(url_done);
	} catch (ex){
	}	
}


function createButton(x,y,no,window){
	var button = new Image(window);
	button.src = "images/greensquare.gif";
	button.width = 17;
	button.hOffset = x;
	button.vOffset = y;
	button.visible = true;
	button.tooltip = "N/A";
	var str = "changeChannel(" + no + ")";
	button.onMouseDown = str;
	return button;
}

function createButtons(){
    x = 7;
    y = 80;
	for (var i=0;i<MAXCHANNELS;++i){
		buttonArray.push(createButton(x,y,i,remote));
		if (i == (NEWROW-1)){
			x = 7;
			y += 16;
		}else {
			x += 16;
		}	
	}
}

function changeChannel(channel){
	if (itemsToRead > 0){
		return;
	}
	for (var i = 0; i<MAXCHANNELS; i++){
		var button = buttonArray[i];
		if (i == channel){
			button.src = "images/greensquare_copy.gif";
		} else {
			button.src = "images/greensquare.gif";
		}
	}
	updateNow();
	preferences.currentChannel.value = channel;
	getFeed();
}

function nextBroadcast(){
	if (timer.readMinutes == -1){
		nextSchedule.data = "Press on the speaker to read the news";
	} else {
		var dt = new Date();
		var remainder = dt.getMinutes() % timer.readMinutes;
		nextMinutes = (dt.getMinutes() - remainder) + timer.readMinutes;
		dt.setMinutes(nextMinutes);
		dt.setSeconds(0);
		nextSchedule.data = "Next newscast : " + dt.toLocaleString();
	}		
}

function readTheTime(){
	var date = new Date();
	var minutes = date.getMinutes();
	var hours  = date.getHours();
	var ampm = hours < 12 ? "A Em" : "Pee Em";
	if (hours == 0){
		hours = 12;
	} else if (hours > 12){
		hours -= 12;
	}
	if (silence == false){
		if (minutes == 0){
			speak("It is " + hours + ampm);
		} else 
			speak("It is " + minutes + " minutes past "  + hours  + ampm);
	}			
}

function readItem(){
	if (silence == true){
		savedItems.length = 0;
		itemsToRead = 0;
	}

	if (savedItems.length > 0){
		readClock.ticking = false;
		var it = savedItems.pop();
		itemsToRead--;
		for (var i=0; i<menuItems.length;++i){
			if (menuItems[i].title == it.title){
	//			scrl.data = menuItems[currentScroll].title;
				updateNow();
				break;
			} 
		}
		
		speak(it.title);
		// does this exist in the old item array
		if ((preferences.readcomplete.value == 1) || (isScheduled == false)){
			speak(it.description);
		} else if ((preferences.readcomplete.value == 2) && (hashItems[escape(it.title)].read == false)){
			speak(it.description);
		}			
		hashItems[escape(it.title)].read = true;
	}
	// carry on reading if we still have something to do
	if (savedItems.length > 0){ 	
		readClock.ticking = true;
	} else {
		readClock.ticking = false;
		if (silence == false){
			speak(preferences.after.value);
		}
		silence = false;	
		preferences.currentChannel.value;
		nextBroadcast();
		readingFeed = false;
	}		
}


function alarmer(){
	var date = new Date();
	var nowMinutes = date.getMinutes();
	if (nowMinutes == 0)
		nowMinutes = 60;
	if ((date.getMinutes() % timer.getMinutes) == 0){
		if (!(timer.chimedGetMinutes == date.getMinutes() && timer.chimedGetHour == date.getHours()))	
		{
			getFeed();
			timer.chimedGetMinutes = date.getMinutes();
			timer.chimedGetHour = date.getHours();
		} 
	} 	
	if (timer.readMinutes != -1){
		if ((date.getMinutes() % timer.readMinutes) == 0){
			if (!(timer.chimedReadMinutes == date.getMinutes() && timer.chimedReadHour == date.getHours()))	
			{
				isScheduled = true;
				readFeed();
				timer.chimedReadMinutes = date.getMinutes();
				timer.chimedReadHour = date.getHours();
			} 
		} 	
	}		
}

function ExtraTimer(){
	this.timer = new Timer();
	this.timer.ticking = true;
	this.timer.interval = 10; // every 10 seconds
	this.chimedGetMinutes = 0;
	this.chimedGetHour = 0;
	this.chimedReadMinutes = 0;
	this.chimedReadHour = 0;
	this.timer.onTimerFired = 'alarmer()';
	this.timer.ticking = true;
}

function readDescription(title){
	var it = hashItems[title];
	if (it != null){
		openURL(it.link);
		if (preferences.silentClick.value < 1){
			speak(it.title);		
			speak(it.description);
		}			
	}
}

function readFeed(){
	// try avoiding interrupts by using a simple variable - not as good as we can 
	// do in a real language 
	silence = false;
	if (itemsToRead == 0){
		itemsToRead = savedItems.length;
		readTheTime();
		speak(preferences.intro.value);
		speak("You are toooned to"); // phonetic
		speak(channeltext.data);
		readClock.ticking = true;
	}		
}

function createPreferencesString(){
	str = feeds[0];
	for (var i=1;i<MAXCHANNELS;++i){
		str = str + "&" + feeds[i];
	}
	preferences.allfeeds.value = str;
}

function showForm2(){
	if (formActive == true){
		return;
	}
	formActive = true;
	var formfields2 = Array();
	var start = MAXCHANNELS/2;
	for (var i=start; i<MAXCHANNELS;++i){
		formfields2[i-start] = new FormField();
		formfields2[i-start].name = 'name' + i ;
		formfields2[i-start].type = 'text';
		formfields2[i-start].title = 'Channel ' + (i+1) ;
		formfields2[i-start].defaultValue = feeds[i];
	}
	var formResults2 = form(formfields2, 'Select Channels 16-30', 'Retune');
	if (formResults2 != null) {
		for (var i=MAXCHANNELS/2; i<MAXCHANNELS;++i){
			feeds[i] =  formResults2[i-start];
		}
		createPreferencesString();
		getFeed();
	}
	for (i=MAXCHANNELS/2; i<MAXCHANNELS;++i){
		showStation(i);
	}
	formActive = false;
}

function showForm(){
	if (formActive == true){
		return;
	}
	formActive = true;
	var formfields = Array();
	for (var i=0; i<MAXCHANNELS/2;++i){
		formfields[i] = new FormField();
		formfields[i].name = 'name' + i ;
		formfields[i].type = 'text';
		formfields[i].title = 'Channel ' + (i+1) ;
		formfields[i].defaultValue = feeds[i];
	}
	var formResults = form(formfields, 'Select Channels 1-15', 'Retune');
	if (formResults != null) {
		for (var i=0; i<MAXCHANNELS/2;++i){
			feeds[i] =  formResults[i];
		}
		createPreferencesString();
		getFeed();
	}		
	for (i=0; i<MAXCHANNELS/2;++i){
		showStation(i);
	}
	formActive = false;
}	
function clearDescription(){
	details.visible = false;
	for (var i=0; i<10; ++i){
		eval("desc"+ i).data="";
	}
}
function stopAndShowDetails(title){
	clearDescription();
	clearTipTimer.ticking = false;
	if ((system.event.screenX + details.width) > screen.availWidth){
		details.hOffset = screen.availWidth - details.width;
	} else {
		details.hOffset = system.event.screenX;
	}
	if ((system.event.screenY + details.height) > screen.availHeight){
		details.vOffset =  screen.availHeight - details.height;
	} else {	
		details.vOffset = system.event.screenY + 20;
	}		
	details.visible = true;
  	scrollInBannermode.ticking=false;
	var it = hashItems[title];
	if (it != null){
		var words = it.description.split(' ');
		var j = 0;
		for (var i=0;i<10; ++i){
			if (j>= words.length) break;
			var str = words[j++];
			while (str.length < 50 && j<words.length){
				str +=  ' ';
				str += words[j++];
			}
			eval("desc" + i).data = str;		
		}
	}
}

function getFeed(){
	var url = new URL();
	contents = url.fetch(feeds[preferences.currentChannel.value]);
	menuItems = new Array();
	try {
	  while (bannerText.length > 0){
	  	var o = bannerText.pop();
	  	o.visible = false;
	  	delete o;
	  }
	} catch (g){
	}
	try {
		var doc = XMLDOM.parse(contents); 
		// first see if this is an rss 2.0 feed
		var root = doc.evaluate("rss").item(0);
		var title;
		savedItems.length=0;
		if (root != null && 
		   ((root.getAttribute("version") == "2.0") || (root.getAttribute("version") == "0.91"))){
			// rss 0.91 or 2.0 feed
			try {
				channeltext.data = doc.evaluate("rss/channel/title").item(0).firstChild.data;
			} catch (ex){
				alert("Problem fetching channel name");
			}
			yabbanner.tooltip = channeltext.data;
			var items = doc.evaluate("rss/*/item");
			var running = 0;
			for(var i=0; i<items.length;++i){
				if (preferences.maxitems.value > 0 && i >= preferences.maxitems.value){
					break;
				}
				try {		
					title = items.item(i).evaluate("title").item(0).firstChild.data;
					link = items.item(i).evaluate("link").item(0).firstChild.data;
					try {
						description = items.item(i).evaluate("description").item(0).firstChild.data;
					} catch (error){
						description = "Not available";
					}	
				var it = new Item(title,description,link);
				savedItems.push(new Item(title,description,link));
				if (hashItems[escape(title)] == null){
					hashItems[escape(title)] = it;
				}	
				menu = new MenuItem();
				menu.title = title;
				menu.enabled = true;
				menu.onSelect = "readDescription(" + "'" + escape(title) + "'" + ")";						 
				menuItems.push(menu);
				} catch (ex){
				}			
				var obj = new Text();
				obj.data = title + " | ";
				obj.window = yabbanner;
				obj.color = preferences.textColor.value;
				obj.bgColor = preferences.bgColor.value;
				obj.bgOpacity = preferences.opacity.value;
				obj.font = preferences.textFont.value;
				obj.size = preferences.textFontSize.value;
				obj.hOffset = running;
				obj.vOffset = obj.height + 20;
				obj.tooltip = channeltext.data;
				running += obj.width;
				obj.onMultiClick = "readDescription(" + "'" + escape(title) + "'" + ")";
				obj.onMouseEnter = "stopAndShowDetails(" + "'" + escape(title) + "'" + ")";
				obj.onMouseExit = "clearTipTimer.ticking = true;"
				bannerText.push(obj);
			}
			var men = new MenuItem();
			men.title = "--------------------------------------------";
			men.enabled = false;
			men.onSelect = "remote.visible = true";
			menuItems.push(men);
			var men = new MenuItem();
			men.title = "Hide Remote";
			men.enabled = true;
			men.onSelect = "remote.visible = false";
			menuItems.push(men);
			men = new MenuItem();
			men.title = "Show Remote";
			men.enabled = true;
			men.onSelect = "remote.visible = true";
			menuItems.push(men);
		} else {
			var root = doc.evaluate("feed").item(0);
			var items = doc.evaluate("/*/entry");
			for(var i=0; i<items.length;++i){
				savedItems.push(new Item(items.item(i).evaluate("title").item(0).firstChild.data,
										 items.item(i).evaluate("description").item(0).firstChild.data));
			}	
		}
		savedItems.reverse();
		menuItems.reverse();
		// now mark old items as still existing
		for (var k in hashItems){
			hashItems[k].stillExists = false;
			
		}

		for (var j=0; j<savedItems.length; ++j){
			var name = escape(savedItems[j].title);
			if (hashItems[name] != null){
				hashItems[name].stillExists = true;
			}
		}
		var delArray = new Array();
		for (k in hashItems){
			if (!hashItems[k].stillExists){
				delArray.push(hashItems[k].title);
			}
		}
		for (j=0; j<delArray.length; ++j){
			var name = delArray[j];
			delete hashItems[name];
		}
	} catch(e){
	}		
}

function scrollBanner(){
	for (var i=0 ; i<bannerText.length; ++i){
		var textItem = bannerText[i];
		textItem.hOffset -= preferences.scrollByPixels.value;
		if ((textItem.hOffset + textItem.width) < 0){
			var lastItem = bannerText[bannerText.length-1];
			var newOffset = lastItem.hOffset + lastItem.width;
			var obj = bannerText.shift();
			obj.hOffset = newOffset;
			i--;
			bannerText.push(obj);
		}
	}
	updateNow();
	

}

function handleDrop(data){
	if (data[0] == "urls" || data[0] == "string"){
		try {
			feeds[preferences.currentChannel.value] = data[1];
			var str;
			str = escape(feeds[0]);
			for (i=1; i<MAXCHANNELS;++i){
				str = str + "&" +feeds[i];
			}
			preferences.allfeeds.value = str;
			getFeed(preferences.currentChannel.value);
			
		} catch(error) {
		}
	}

}

function startTimers(){
	timer = new ExtraTimer();
}

function bannerTextStyle(){
	for (var i=0; i<bannerText.length;++i){
		bannerText[i].font = preferences.textFont.value;
		bannerText[i].color = preferences.textColor.value;
		bannerText[i].size = preferences.textFontSize.value;
		bannerText[i].bgColor = preferences.bgColor.value;
		bannerText[i].bgOpacity = preferences.opacity.value;
		bannerText[i].width = -1;
		bannerText[i].vOffset = 10 + bannerText[i].height;

	}	

}

function updateBehaviour(){
	timer.readMinutes = parseInt(preferences.updateSchedule.value);
	feeds = preferences.allfeeds.value.split('&');
	if (feeds.length < MAXCHANNELS){
		var nos = MAXCHANNELS - feeds.length;
		var str = "http://www.siliconvalley.com/mld/mercurynews/entertainment/rss.xml&http://www.comedycentral.com/rss/jokes/index.jhtml&http://feeds.bignewsnetwork.com/?rss=3f2b7a1e7169fe72&http://www.humorama.com/rss/daily&http://www.office-humour.co.uk/syndication/rss/quotes.xml&http://www.office-humour.co.uk/syndication/rss/onelinersqa.xml&http://feeds.office-humour.co.uk/xml/popular.xml&http://www.rd.com/wtexcld/rssFeeds/F_articleFeed.xml&http://www.britannica.com/eb/dailycontent/rss&http://www.prweb.com/rss2/landscapinggardening.xml&http://www.foodclassics.com/rss-newrecipes.php&http://www.nasa.gov/rss/science_at_nasa.rss&http://www.sciencedaily.com/newsfeed.xml&http://www.washingtonpost.com/wp-dyn/rss/health/index.xml&http://www.scienceblog.com/cms/rss.xml";		
		var feeds2 = str.split('&');
		for (var z=0; z<nos;++z){
			feeds.push(feeds2[z]);
		}
	}
	switch(timer.readMinutes){
		// update upto 10 minutes before
		case -1:
		case 60:
			var randomNumber=Math.floor(Math.random()*11)
			timer.getMinutes = 60 - randomNumber;
		break;
		
		case 30:
			var randomNumber=Math.floor(Math.random()*8)
			timer.getMinutes = 30 - randomNumber;
		break;
		
		case 15:
			var randomNumber=Math.floor(Math.random()*8)
			timer.getMinutes = 15 - randomNumber;
		break;
		
		case 5:
			var randomNumber=Math.floor(Math.random()*4)
			timer.getMinutes = 5 - randomNumber;
		break;
	}
	changeChannel(preferences.currentChannel.value);
	for (var i=0; i<MAXCHANNELS;++i){
		showStation(i);
	}
	nextBroadcast();
	readClock.ticking = false;
	readClock.interval = preferences.storyInterval.value;
	randomMode.ticking = preferences.randomModeOn.value;
	randomMode.interval = preferences.randomChange.value;
	scrollInBannermode.interval = preferences.scrollSpeed.value;
	bannerTextStyle();
}

function RemoveMarkup(str){
	var finalStr = new String();
	var countIn = true;
	for (var j=0; j<str.length; ++j){
		var ch =  str.charAt(j);
		if (ch == '<'){
			countIn = false;
		} else if (ch == '>'){
			countIn = true;
		} else if (countIn){
			finalStr = finalStr + ch;
		}
	}
	return finalStr;
}